/**************************************************************************
 *
 * BROWSE.C
 * 
 **************************************************************************/

/***************************************************************************
 *
 * @(#) browse.c 1.2@(#)
 *
 ***************************************************************************/
 
#ifndef linlint
static char *sccsid="@(#) browse.c 1.2@(#)";
#endif


#include "types.h"
#include "browse.h"
#include "dua.h"
#include "textdpy.h"
#include "entrylist.h"
#include "query.h"

/*
 * Few misc gobal type variables...
 */

extern char CurrentEntry[BUFLEN];
static void Result();
static void Report();

/*****************************************************************************
 * Browse()
 *
 * 
 *
 ****************************************************************************/

void Browse(name)
     STRING name;
{
QyErrorCode err;

/*
 * Clear the data window ready for status messages etc..
 */

ClearData();
SetMessage("Browsing below entry");

/*
 * Look to ensure we have something to browse under
 */

if (CurrentEntry[0] == '\0')
    {
      AddData("No entry given to browse under!\n");
      Scrollbar('\0');
      return;
    }

/*
 * If we do, then display a message saying we are browsing and call the 
 * query engine to kick it off...
 */

  AddData("Browsing, please wait.\n");
  AddData("[press ctrl-C to abort]\n\n");
  Scrollbar('\0');

  err = QyBrowse(CurrentEntry, NULL, &req_id);

/*
 * Make sure that there are no errors, and if there are display them and
 * exit. Some of these could be tidied up...
 */

  switch (err)
    {
    case QERR_bad_name:
      
      AddData("Invalid entry name.\n");
      Scrollbar('\0');
      return;

    case QERR_internal_limit_reached:

      AddData("Internal limit reached.\n");
      Scrollbar('\0');
      return;
    }

/*
 * Do it!
 */

  DirectoryWait(req_id, Result, Report);

} /* Browse */

/*****************************************************************************
 * Report()
 *
 * A search status report has been received.
 *
 ****************************************************************************/

static void Report(reqid)
     int reqid;
{

/*
 * None of this should work :) Its here as a reminder to me :)
 *

  char msg[BUFLEN];
  QyUFNReport report;

  report = QyGetUFNReport(reqid);

  switch (report->type)
    {
    case QyUFNmatches:

      (void) sprintf
        (msg, "Made %d match for `%s'.\n", 1, report->resolved);

      break;

    case QyUFNattempt:

      (void) sprintf(msg, "Search restarted.\n");
      break;
    }

  AddData(msg);
  Scrollbar('\0');

  QyFreeUFNReport(&report);
*/

} /* Report */

/*****************************************************************************
 * Result()
 *
 * Evaluate the results and invoke entrylist...
 *
 ****************************************************************************/

static void Result(reqid)
     int reqid;
{
  browseResults result;
  QyErrorList errors;

/*
 * Set up the result status and structure
 */

  result = get_browse_results(reqid);

/*
 * Clear the screen and say we have a result...
 */

  AddData("Result received.\n");

/*
 * Look to see if we have any results....
 */
  if (result->entries == NULLEntryList)
    {

/*
 * If we dont, then look to see if it was just nothing found or an error
 */

      if (result->errors == NULLError)
        {
          AddData("Error: Nothing found under entry.\n\n");
	  Scrollbar('\0');
        }
      else
        {
          AddData("Error: Couldn't browse under entry.\n\n");
	  Scrollbar('\0');
        }
    } 

/*
 * Otherwise obtain the list of entries and display either...
 * the entry if there is only 1 or
 * a list of the matches using entrylist
 */

  else
    {
      int hitnum;
      entryList pentry;

/*
 * Work out howmany entries their are by descending the results list
 */

      for (pentry = result->entries, hitnum = 0;
	 pentry != NULLEntryList;
         pentry = pentry->next, hitnum++)
      ;

/*
 * If there is just one then display it...
 */
    if (hitnum == 1)
    {
      AddHistory("Browse:",result->entries->string_dn);
      Show(result->entries->string_dn);
    }

/*
 * Otherwise present a list of options.
 */
   else if (hitnum > 1)
    {
      /* SetEntryList(result->matches); */
      SetEntryList(result->entries);
      (void) ShowEntryList();
    }
   }

/*
 * Display the screen and end :)
 */

  Scrollbar('\0');
  result->errors = NULLError;
} /* Result */
