/**************************************************************************
 *
 * INIT.C - Initialize (read configuration, etc
 * 
 ***************************************************************************/

/***************************************************************************
 *
 * @(#) init.c 1.6@(#)
 *
 ***************************************************************************/
 
#ifndef lint
static char *sccsid="@(#) init.c 1.4@(#)";
#endif


#include "types.h"
#include "query.h"
#include "init.h"

/**************************************************
 *
 * Local functions.
 * 
 */

static void ReadTailor();

/**************************************************
 *
 * Local types.
 * 
 */

typedef struct _DBEntry
{
  STRING key;
  STRING value;
  struct _DBEntry *next;
} *DBEntry;

/**************************************************
 *
 * Local data.
 * 
 */

static DBEntry localdb = (DBEntry) NULL;

/**************************************************
 *
 * Global data.
 * 
 */

extern char config_file_name[BUFLEN];
FILE *confile;
int TailorLineNumber = 0;

/*****************************************************************************
 * Initialize()
 *
 * 
 *
 ****************************************************************************/

void Initialize()
{
  ReadTailor();
} /* Initialize */

/*****************************************************************************
 * ReadTailor()
 *
 * Read configuration file.
 *
 ****************************************************************************/

static void ReadTailor()
{
  extern int yyparse();
  extern char CurrentEntry[];
  extern char *local_dit;
  extern void EndWidgets();

  char isode_config_file[BUFLEN];
  char user_config_file[BUFLEN];

  CurrentEntry[0]='\0';

  strcpy(user_config_file,getenv ("HOME"));
  strcat(user_config_file,"/.slurc");

  strcpy(isode_config_file,ETCDIR);
  strcat(isode_config_file,"slu/slurc");
  
  if ((confile = fopen(config_file_name, "r"))==NULL)
     {
       if ((confile = fopen(user_config_file, "r"))==NULL)
         {
  	    if ((confile = fopen(isode_config_file, "r"))==NULL)
                {
		   EndWidgets();
		   (void) ds_unbind();
		   hide_picture();
		   printf("\nCouldn't find user configuration file!\n\n");
		   printf("Locations checked:\n%s\n%s\n%s\n",
				user_config_file,
				isode_config_file,
				config_file_name);
		   printf("A likely cause of this error is that SLU has been");
		   printf(" incorrectly installed or that\nthe global ");
		   printf("configuration file has the wrong permissions.  ");
		   printf("See the SLU manual\npage for help in setting up");
		   printf(" an \"slurc\" file\n\n");
      		   exit(1);
		}
         }
    }
	

  if ((local_dit != NULL) && (*local_dit!=NULL))
  	(void) strcpy(CurrentEntry, local_dit);

  (void) yyparse();

} /* ReadTailor */


/*****************************************************************************
 * AddDBEntry()
 *
 * 
 *
 ****************************************************************************/

void AddDBEntry(key, value)
     STRING key;
     STRING value;
{
  DBEntry add;

  add = (DBEntry) malloc(sizeof(struct _DBEntry));

  add->next = localdb;
  localdb = add;

  add->key = QyCopyString(key);
  add->value = QyCopyString(value);
} /* AddDBEntry */

/*****************************************************************************
 * GetDBEntry()
 *
 * 
 *
 ****************************************************************************/

STRING GetDBEntry(key)
     STRING key;
{
  DBEntry dbent;

  for (dbent = localdb; dbent != (DBEntry) NULL; dbent = dbent->next)
    {
      if (lexequ(dbent->key, key) == 0)
	return dbent->value;
    }

  return key;
} /* GetDBEntry */
