#include "query.h"

/***************************************************************************
 *
 * @(#) request.c 1.2@(#)
 *
 ***************************************************************************/
 
#ifndef lint
static char *sccsid="@(#) request.c 1.2@(#)";
#endif


static void DirectoryWork();

/*****************************************************************************
 * RequestInvoked()
 *
 * A request has been invoked. Call the supplied callbacks when reports or
 * results come in.
 *
 ****************************************************************************/

void RequestInvoked(int requestId, SLUresultCB rescb, SLUreportCB repcb)
{
  fd_set association, writefds, exceptfds;
  BOOLEAN done;

  extern int dsap_ad;
  
  done = FALSE;
  while (done == FALSE)
    {
      /* Wait for something to come in */
      do
	{
	  FD_ZERO(&assoc);
	  FD_ZERO(&writefds);
	  FD_ZERO(&exceptfds);
	  FD_SET(dsap_ad, &assoc);
	}
      while (select(getdtablesize(), &assoc, &writefds, &exceptfds, NULL) <=0);

      /* Process incoming result */
      DirectoryWork(requestId, rescb, repcb);
    }
} /* RequestInvoked */

/*****************************************************************************
 * DirectoryWork()
 *
 * Process an incoming directory result PDU. Call the appropriate
 * user callback procedure.
 *
 ****************************************************************************/

void DirectoryWork()
{
} /* DirectoryWork */
