/*
 * Pretty print type manipulation routines:
 *
 * InitTermPrint- set it all up
 * boldon	- turn on bold
 * bolfoff	- turn off bold
 * inverseon    - turn on inverse
 * inverseoff	- turn off inverse
 * underlineon	- turn on underline
 * underlineoff	- turn off underline
 */

/***************************************************************************
 *
 * @(#) termprint.c 1.2@(#)
 *
 ***************************************************************************/
 
#ifndef lint
static char *sccsid="@(#) termprint.c 1.2@(#)";
#endif

#include <stdio.h>
#include "termprint.h"

char _capabilities[BUFLEN];
char *ptr = _capabilities;
char *_setinverse, *_clearinverse, *_setunderline, *_clearunderline;
char *_setbold, *_clearbold;

int outchar();

extern char * tgetstr();

/*
 * InitTermPrint - initialse strings from termcap
 */

void InitTermPrint()
{
  _setinverse     = tgetstr ("so", &ptr);
  _clearinverse   = tgetstr ("se", &ptr);
  _setunderline   = tgetstr ("us", &ptr);
  _clearunderline = tgetstr ("ue", &ptr);
  _setbold	  = tgetstr ("md", &ptr);
  _clearbold	  = tgetstr ("me", &ptr); /* This is actually ALL attrs off! */
       
/*
 * kludge to workaround no inverse
 */
	     
  if (_setinverse == 0) {
	_setinverse = _setunderline;
	_clearinverse = _clearunderline;
	}
}

/*
 * boldon - turn on bold (or inverse depending on the terminal) text
 */

void boldon()
{
  tputs(_setbold,1,outchar);
}

/*
 * boldoff - turn off bold/inverse text
 */

void boldoff()
{
  tputs(_clearbold,1,outchar);
}

/*
 * inverseon - turn on inverse chars
 */

void inverseon()
{
  tputs(_setinverse,1,outchar);
}

/*
 * inverseoff
 */

void inverseoff()
{
  tputs(_clearinverse,1,outchar);
}

/*
 * underlineon - turn on underline text
 */

void underlineon()
{
  tputs(_setunderline,1,outchar);
}

/*
 * underlineoff - turn off underlined text
 */

void underlineoff()
{
  tputs(_clearunderline,1,outchar);
}

/*
 * Misc function needed by tputs - CANNOT BE A MACRO!
 */

int outchar(c)
  int c;
{
  fputc (c, stdout);
}
