/***************************************************************************
 *
 * TEXTDPY.C - Text data display.
 * 
 ***************************************************************************/

/***************************************************************************
 *
 * @(#) textdpy.c 1.2@(#)
 *
 ***************************************************************************/
 
#ifndef lint
static char *sccsid="@(#) textdpy.c 1.2@(#)";
#endif


#include "widget.h"
#include "types.h"
#include "message.h"
#include "sequence.h"

/**************************************************
 *
 * External data.
 * 
 */

extern WINDOW *DataWindow;

/**************************************************
 *
 * Local data.
 * 
 */

stringList DataList = NULLStrCell;

/*****************************************************************************
 * ClearData()
 *
 * 
 *
 ****************************************************************************/

void ClearData()
{
  ClearWindow(DataWindow);
  SeqFree(&DataList);
} /* ClearData */

/*****************************************************************************
 * AddData()
 *
 * 
 *
 ****************************************************************************/

void AddData(str)
     STRING str;
{
  SeqAppendString(str, &DataList);
} /* AddData */

/*****************************************************************************
 * ShowData()
 *
 * Show text data beginning at line idx.
 *
 ****************************************************************************/

void ShowData(idx)
     int idx;
{
  int count;
  stringCell curr;

  curr = DataList;
  for (count = 0; count < idx; count++)
    {
      if (curr == NULLStrCell)
	break;

      curr = curr->next;
    }

  if (curr != NULLStrCell)
    {
      extern int DataHeight;

      wclear(DataWindow);
      wmove(DataWindow, 0, 0);

      for (count = 0; count < DataHeight; count++)
	{
	  if (curr == NULLStrCell)
	    break;

	  wprintw(DataWindow, "%s", curr->string);
	  curr = curr->next;
	}
    }

  wrefresh(DataWindow);
} /* ShowData */

